import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import React, { Component, Fragment } from 'react';
import MoleculeDropdownList from '@s-ui/react-molecule-dropdown-list';
import MoleculeInputTags from '@s-ui/react-molecule-input-tags';
import withClearUI from '../hoc/withClearUI';
var MoleculeInputTagsWithClearUI = withClearUI(MoleculeInputTags);

var MoleculeAutosuggestFieldMultiSelection =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(MoleculeAutosuggestFieldMultiSelection, _Component);

  function MoleculeAutosuggestFieldMultiSelection() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.MoleculeInputTagsRef = React.createRef();

    _this.handleMultiSelection = function (ev, _ref) {
      var value = _ref.value;
      var _this$props = _this.props,
          refMoleculeAutosuggest = _this$props.refMoleculeAutosuggest,
          tags = _this$props.tags,
          onChangeTags = _this$props.onChangeTags,
          onToggle = _this$props.onToggle;
      var newTags = tags.includes(value) ? tags.filter(function (tag) {
        return tag !== value;
      }) : [].concat(tags, [value]);
      onChangeTags(ev, {
        value: '',
        tags: newTags
      });
      onToggle(ev, {
        isOpen: false
      });
      refMoleculeAutosuggest.current.focus();
    };

    _this.handleChangeTags = function (ev, _ref2) {
      var tags = _ref2.tags,
          value = _ref2.value;
      var _this$props2 = _this.props,
          refMoleculeAutosuggest = _this$props2.refMoleculeAutosuggest,
          onChangeTags = _this$props2.onChangeTags,
          onToggle = _this$props2.onToggle;
      var isOpen = Boolean(value);
      onChangeTags(ev, {
        tags: tags
      });
      onToggle(ev, {
        isOpen: isOpen
      });
      refMoleculeAutosuggest.current.focus();
    };

    _this.handleChange = function (ev, _ref3) {
      var value = _ref3.value;
      var _this$props3 = _this.props,
          onChange = _this$props3.onChange,
          onToggle = _this$props3.onToggle;
      var isOpen = Boolean(value);
      onChange(ev, {
        value: value
      });
      onToggle(ev, {
        isOpen: isOpen
      });
    };

    _this.handleClear = function () {
      var _this$props4 = _this.props,
          onChange = _this$props4.onChange,
          onChangeTags = _this$props4.onChangeTags;
      onChange(null, {
        value: ''
      });
      onChangeTags(null, {
        tags: []
      });
    };

    return _this;
  }

  var _proto = MoleculeAutosuggestFieldMultiSelection.prototype;

  _proto.render = function render() {
    var handleMultiSelection = this.handleMultiSelection,
        handleChangeTags = this.handleChangeTags,
        handleChange = this.handleChange,
        handleClear = this.handleClear,
        MoleculeInputTagsRef = this.MoleculeInputTagsRef;
    var _this$props5 = this.props,
        tags = _this$props5.tags,
        value = _this$props5.value,
        onToggle = _this$props5.onToggle,
        iconCloseTag = _this$props5.iconCloseTag,
        isOpen = _this$props5.isOpen,
        iconClear = _this$props5.iconClear,
        innerRefInput = _this$props5.innerRefInput,
        placeholder = _this$props5.placeholder,
        children = _this$props5.children,
        onInputKeyDown = _this$props5.onInputKeyDown,
        disabled = _this$props5.disabled;
    return React.createElement(Fragment, null, React.createElement(MoleculeInputTagsWithClearUI, {
      onKeyDown: onInputKeyDown,
      ref: MoleculeInputTagsRef,
      tags: tags,
      value: value,
      onClick: onToggle,
      tagsCloseIcon: !disabled && iconCloseTag,
      onChangeTags: handleChangeTags,
      onChange: handleChange,
      isOpen: isOpen,
      isVisibleClear: !disabled && tags.length,
      iconClear: iconClear,
      onClickClear: handleClear,
      innerRefInput: innerRefInput,
      placeholder: !tags.length ? placeholder : '',
      noBorder: true,
      disabled: disabled
    }), React.createElement(MoleculeDropdownList, {
      checkbox: true,
      visible: isOpen,
      onSelect: handleMultiSelection,
      value: tags,
      highlightQuery: value
    }, children));
  };

  return MoleculeAutosuggestFieldMultiSelection;
}(Component);

MoleculeAutosuggestFieldMultiSelection.displayName = 'MoleculeAutosuggestFieldMultiSelection';
MoleculeAutosuggestFieldMultiSelection.defaultProps = {
  disabled: false,
  value: '',
  tags: [],
  iconCloseTag: React.createElement("span", null)
};
export default MoleculeAutosuggestFieldMultiSelection;