import React, { Fragment } from 'react';
import MoleculeDropdownList from '@s-ui/react-molecule-dropdown-list';
import AtomInput from '@s-ui/react-atom-input';
import withClearUI from '../hoc/withClearUI';
var AtomInputWithClearUI = withClearUI(AtomInput);

var MoleculeAutosuggestSingleSelection = function MoleculeAutosuggestSingleSelection(props) {
  /* eslint-disable react/prop-types */
  var _props$value = props.value,
      value = _props$value === void 0 ? '' : _props$value,
      children = props.children,
      isOpen = props.isOpen,
      onToggle = props.onToggle,
      onChange = props.onChange,
      onInputKeyDown = props.onInputKeyDown,
      size = props.size,
      innerRefInput = props.innerRefInput,
      refMoleculeAutosuggest = props.refMoleculeAutosuggest,
      iconClear = props.iconClear,
      placeholder = props.placeholder,
      disabled = props.disabled;

  var handleSelection = function handleSelection(ev, _ref) {
    var value = _ref.value;
    onChange(ev, {
      value: value
    });
    onToggle(ev, {
      isOpen: false
    });
    refMoleculeAutosuggest.current.focus();
  };

  var handleChange = function handleChange(ev, _ref2) {
    var value = _ref2.value;
    onChange(ev, {
      value: value
    });
    onToggle(ev, {
      isOpen: true
    });
  };

  var handleClear = function handleClear() {
    onChange(null, {
      value: ''
    });
  };

  return React.createElement(Fragment, null, React.createElement(AtomInputWithClearUI, {
    value: value,
    isVisibleClear: value,
    onClickClear: handleClear,
    onChange: handleChange,
    iconClear: !disabled && iconClear,
    reference: innerRefInput,
    placeholder: placeholder,
    onKeyDown: onInputKeyDown,
    disabled: disabled
  }), value && React.createElement(MoleculeDropdownList, {
    isOpen: isOpen,
    size: size,
    visible: isOpen,
    onSelect: handleSelection,
    value: value,
    highlightQuery: value
  }, children));
};

MoleculeAutosuggestSingleSelection.displayName = 'MoleculeAutosuggestSingleSelection';
MoleculeAutosuggestSingleSelection.defaultProps = {
  value: ''
};
export default MoleculeAutosuggestSingleSelection;