import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { moleculeDropdownListSizes as SIZES } from '@s-ui/react-molecule-dropdown-list';
import MoleculeAutosuggestSingleSelection from './components/SingleSelection';
import MoleculeAutosuggestMultipleSelection from './components/MultipleSelection';
import { withOpenToggle } from '@s-ui/hoc';
import { getTarget } from '@s-ui/js/lib/react';
import { getCurrentElementFocused } from '@s-ui/js/lib/dom';
var BASE_CLASS = "sui-MoleculeAutosuggest";
var CLASS_FOCUS = BASE_CLASS + "--focus";
var CLASS_DISABLED = BASE_CLASS + "--disabled";

var getIsTypeableKey = function getIsTypeableKey(key) {
  var keysEdit = ['Backspace', 'Enter', 'Meta', 'Shift', 'ArrowLeft', 'ArrowRight'];
  return key.length === 1 || keysEdit.includes(key);
};

var MoleculeAutosuggest =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(MoleculeAutosuggest, _Component);

  function MoleculeAutosuggest() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.refMoleculeAutosuggest = _this.props.refMoleculeAutosuggest || React.createRef();
    _this.refsMoleculeAutosuggestOptions = [];
    _this.refMoleculeAutosuggestInput = React.createRef();
    _this.state = {
      focus: false
    };

    _this.closeList = function (ev) {
      var _this$props = _this.props,
          onToggle = _this$props.onToggle,
          onChange = _this$props.onChange,
          multiselection = _this$props.multiselection;

      var _assertThisInitialize = _assertThisInitialized(_this),
          domMoleculeAutosuggest = _assertThisInitialize.refMoleculeAutosuggest.current;

      onToggle(ev, {
        isOpen: false
      });
      if (multiselection) onChange(ev, {
        value: ''
      });
      domMoleculeAutosuggest.focus();
      ev.preventDefault();
      ev.stopPropagation();
    };

    _this.focusFirstOption = function (ev, _ref) {
      var options = _ref.options;
      if (options[0]) options[0].focus();
      ev.preventDefault();
      ev.stopPropagation();
    };

    _this.handleKeyDown = function (ev) {
      ev.persist();
      var _this$props2 = _this.props,
          isOpen = _this$props2.isOpen,
          keysCloseList = _this$props2.keysCloseList,
          keysSelection = _this$props2.keysSelection;

      var _assertThisInitialize2 = _assertThisInitialized(_this),
          refsMoleculeAutosuggestOptions = _assertThisInitialize2.refsMoleculeAutosuggestOptions,
          domInnerInput = _assertThisInitialize2.refMoleculeAutosuggestInput.current,
          domMoleculeAutosuggest = _assertThisInitialize2.refMoleculeAutosuggest.current,
          closeList = _assertThisInitialize2.closeList,
          focusFirstOption = _assertThisInitialize2.focusFirstOption;

      var key = ev.key;
      var options = refsMoleculeAutosuggestOptions.map(getTarget);
      var isTypeableKey = getIsTypeableKey(key);
      var isSelectionKey = keysSelection.includes(key);

      if (isTypeableKey) {
        if (!isSelectionKey) domInnerInput.focus();
      } else domMoleculeAutosuggest.focus();

      if (isOpen) {
        var currentElementFocused = getCurrentElementFocused();
        var isSomeOptionFocused = [].concat(options).includes(currentElementFocused);
        if (keysCloseList.includes(key)) closeList(ev);else if (key === 'ArrowDown' && !isSomeOptionFocused) focusFirstOption(ev, {
          options: options
        });else if (isSomeOptionFocused) _this.handleFocusIn(ev);
      }
    };

    _this.handleFocusIn = function (ev) {
      _this.setState({
        focus: true
      });
    };

    _this.handleFocusOut = function (ev) {
      ev.persist();

      var _assertThisInitialize3 = _assertThisInitialized(_this),
          refsMoleculeAutosuggestOptions = _assertThisInitialize3.refsMoleculeAutosuggestOptions,
          domInnerInput = _assertThisInitialize3.refMoleculeAutosuggestInput.current,
          closeList = _assertThisInitialize3.closeList;

      var options = refsMoleculeAutosuggestOptions.map(getTarget);
      var isOpen = _this.props.isOpen;
      setTimeout(function () {
        var currentElementFocused = getCurrentElementFocused();
        var focusOutFromOutside = ![domInnerInput].concat(options).includes(currentElementFocused);
        if (focusOutFromOutside && isOpen) closeList(ev);
      }, 1);

      _this.setState({
        focus: false
      });
    };

    _this.handleInputKeyDown = function (ev) {
      var key = ev.key;
      if (key !== 'ArrowDown') ev.stopPropagation();
    };

    return _this;
  }

  var _proto = MoleculeAutosuggest.prototype;

  _proto.render = function render() {
    var _this$props3 = this.props,
        multiselection = _this$props3.multiselection,
        props = _objectWithoutProperties(_this$props3, ["multiselection"]);

    var className = this.className,
        handleKeyDown = this.handleKeyDown,
        extendedChildren = this.extendedChildren,
        refMoleculeAutosuggest = this.refMoleculeAutosuggest,
        refMoleculeAutosuggestInput = this.refMoleculeAutosuggestInput,
        handleFocusIn = this.handleFocusIn,
        handleFocusOut = this.handleFocusOut,
        handleInputKeyDown = this.handleInputKeyDown;
    return React.createElement("div", {
      ref: refMoleculeAutosuggest,
      tabIndex: "0",
      className: className,
      onKeyDown: handleKeyDown,
      onFocus: handleFocusIn,
      onBlur: handleFocusOut
    }, multiselection ? React.createElement(MoleculeAutosuggestMultipleSelection, Object.assign({}, props, {
      onInputKeyDown: handleInputKeyDown,
      refMoleculeAutosuggest: refMoleculeAutosuggest,
      innerRefInput: refMoleculeAutosuggestInput
    }), extendedChildren) : React.createElement(MoleculeAutosuggestSingleSelection, Object.assign({}, props, {
      onInputKeyDown: handleInputKeyDown,
      refMoleculeAutosuggest: refMoleculeAutosuggest,
      innerRefInput: refMoleculeAutosuggestInput
    }), extendedChildren));
  };

  _createClass(MoleculeAutosuggest, [{
    key: "extendedChildren",
    get: function get() {
      var _this$props4 = this.props,
          children = _this$props4.children,
          keysSelection = _this$props4.keysSelection; // eslint-disable-line react/prop-types

      var refsMoleculeAutosuggestOptions = this.refsMoleculeAutosuggestOptions;
      return React.Children.toArray(children).filter(Boolean).map(function (child, index) {
        refsMoleculeAutosuggestOptions[index] = React.createRef();
        return React.cloneElement(child, {
          innerRef: refsMoleculeAutosuggestOptions[index],
          onSelectKey: keysSelection
        });
      });
    }
  }, {
    key: "className",
    get: function get() {
      var _cx;

      var focus = this.state.focus;
      var disabled = this.props.disabled;
      return cx(BASE_CLASS, (_cx = {}, _cx[CLASS_FOCUS] = focus, _cx[CLASS_DISABLED] = disabled, _cx));
    }
  }]);

  return MoleculeAutosuggest;
}(Component);

MoleculeAutosuggest.defaultProps = {
  onChange: function onChange() {},
  onToggle: function onToggle() {},
  keysSelection: [' ', 'Enter'],
  keysCloseList: ['Escape']
};
export default withOpenToggle(MoleculeAutosuggest);
export { SIZES as MoleculeAutosuggestDropdownListSizes };